RWStructuredBuffer<float4> rangeBuffer;
RWStructuredBuffer<float4> finalRangeBuffer;

[numthreads(1, 1, 1)]
void main(uint3 gid : SV_GroupID, uint3 dtid : SV_DispatchThreadID)
{
  float2 range = { 100000, -100000 };

  for (int y = 0; y < NUM_GROUPS; ++y) {
    for (int x = 0; x < NUM_GROUPS; ++x) {
      float4 value = rangeBuffer[y * NUM_GROUPS + x];

      range.x = min(range.x, value.x);
      range.y = max(range.y, value.y);
    }
  }

  if (range.x > range.y) range = float2(0, 0);

  finalRangeBuffer[0] = lerp(finalRangeBuffer[0], float4(range, 0, 0), 0.1);
}
