cbuffer LevelTextureParameters
{
  float4x4 projectionMatrix;

  float2 oneOverTextureSize;
};

cbuffer RegionParameters
{
  float2 sourceOrigin;
  float2 updateSize;
  float2 destinationOffset;
  int clear;
  float4 clearValue;
};

struct VertexIn
{
  float2 Position : POSITION0;
};

struct VertexOut
{
  float4 Position : SV_Position;
  float2 TexCoords : TEXCOORD0;
};

VertexOut main(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

  float2 scaledPosition = In.Position * updateSize;

  Out.TexCoords = (scaledPosition + sourceOrigin) * oneOverTextureSize;
  Out.Position = mul(float4(scaledPosition + destinationOffset, 0.0, 1.0), projectionMatrix);

  return Out;
}
